// DGManagerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DGManager.h"
#include "DGManagerDlg.h"
#include "DGComm.h"
#include "DlgPort.h"
#include "DlgView.h"
#include "DlgConfig.h"
#include "IniEx.h"
#include "DLLGFX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE cf; // Canal de communication entre le gant et le PC

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDGManagerDlg dialog

CDGManagerDlg::CDGManagerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDGManagerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDGManagerDlg)
	m_AN1 = _T("");
	m_AN2 = _T("");
	m_AN3 = _T("");
	m_AN4 = _T("");
	m_AN5 = _T("");
	m_AN6 = _T("");
	m_AN10 = _T("");
	m_AN11 = _T("");
	m_AN12 = _T("");
	m_AN7 = _T("");
	m_AN8 = _T("");
	m_AN9 = _T("");
	m_AN13 = _T("");
	m_AN14 = _T("");
	m_AN15 = _T("");
	m_AN17 = _T("");
	m_AN16 = _T("");
	m_AN18 = _T("");
	m_AN19 = _T("");
	m_AN20 = _T("");
	m_AN21 = _T("");
	m_AN22 = _T("");
	m_AN23 = _T("");
	m_AN24 = _T("");
	m_VEchelle = _T("");
	m_Canaux = -1;
	m_debit = _T("");
	m_Fps = _T("");
	m_Freq = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CDGManagerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDGManagerDlg)
	DDX_Control(pDX, IDC_GO, m_GoButton);
	DDX_Text(pDX, IDC_EDIT1, m_AN1);
	DDX_Text(pDX, IDC_EDIT2, m_AN2);
	DDX_Text(pDX, IDC_EDIT3, m_AN3);
	DDX_Text(pDX, IDC_EDIT4, m_AN4);
	DDX_Text(pDX, IDC_EDIT5, m_AN5);
	DDX_Text(pDX, IDC_EDIT6, m_AN6);
	DDX_Text(pDX, IDC_EDIT10, m_AN10);
	DDX_Text(pDX, IDC_EDIT11, m_AN11);
	DDX_Text(pDX, IDC_EDIT12, m_AN12);
	DDX_Text(pDX, IDC_EDIT7, m_AN7);
	DDX_Text(pDX, IDC_EDIT8, m_AN8);
	DDX_Text(pDX, IDC_EDIT9, m_AN9);
	DDX_Text(pDX, IDC_EDIT13, m_AN13);
	DDX_Text(pDX, IDC_EDIT14, m_AN14);
	DDX_Text(pDX, IDC_EDIT15, m_AN15);
	DDX_Text(pDX, IDC_EDIT17, m_AN17);
	DDX_Text(pDX, IDC_EDIT16, m_AN16);
	DDX_Text(pDX, IDC_EDIT18, m_AN18);
	DDX_Text(pDX, IDC_EDIT19, m_AN19);
	DDX_Text(pDX, IDC_EDIT20, m_AN20);
	DDX_Text(pDX, IDC_EDIT21, m_AN21);
	DDX_Text(pDX, IDC_EDIT22, m_AN22);
	DDX_Text(pDX, IDC_EDIT23, m_AN23);
	DDX_Text(pDX, IDC_EDIT24, m_AN24);
	DDX_Text(pDX, IDC_EDIT25, m_VEchelle);
	DDX_CBIndex(pDX, IDC_COMBO1, m_Canaux);
	DDX_Text(pDX, IDC_Debit, m_debit);
	DDX_Text(pDX, IDC_FPS, m_Fps);
	DDX_Text(pDX, IDC_Freq, m_Freq);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDGManagerDlg, CDialog)
	//{{AFX_MSG_MAP(CDGManagerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID__ABOUT, OnAbout)
	ON_COMMAND(ID_FICHIER_QUITTER, OnFichierQuitter)
	ON_COMMAND(ID_GLOVE_CONNECT, OnGloveConnect)
	ON_COMMAND(ID_AFFICHAGE_OPTIONS, OnAffichageOptions)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_GO, OnGo)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_COMMAND(ID_FICHIER_ENREGISTRERLOG, OnFichierEnregistrerlog)
	ON_COMMAND(ID_GLOVE_CALIBRATE, OnGloveCalibrate)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_GLOVE_CONFIG, OnGloveConfig)
	ON_COMMAND(ID_GLOVE_MAIN3D, OnGloveMain3d)
	//}}AFX_MSG_MAP
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDGManagerDlg message handlers

BOOL CDGManagerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	// Cration de la zone d'affichage

	CRect rect(170, 75, 450, 375);
	m_pDisplay.Create( NULL,   //CWnd default
						NULL,   //has no name
						WS_CHILD|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_VISIBLE,
						rect,
						this,   //this is the parent
						0);     //this should really be a different number... check resource.h


	// Initialisation de la police
	font.CreateFont(12,0,0,0,FW_NORMAL,FALSE,FALSE,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_ROMAN,"Times New Roman");

	// Initialisation de la variable grant l'chantillonage
	Timer=0;
	Canal=2;
	m_Canaux=0;

	// Initialisation status
	connected=false;
	go=false;
	m_View3D=false;

	// Variable d'information pour la barre de status
	m_debit="Not Connected";
	m_IDebit=0;
	m_Ifps=0;
	m_IFreq=0;
	
	// Initialisation des variables de l'chelle
	m_Echelle_min=10000;
	m_Echelle_max=50000;
	m_VEchelle="25000";
	m_Amplitude=1023;

	// variable de reprsentation du graphe
	m_raw_data=true;	
	m_scaled_data=false;
	m_calibrate_data=false;
	m_scope=false;
	m_P1=false;

	// Initailissation de la barre d'chelle
	CWnd* pWnd = GetDlgItem( IDC_SLIDER_POS ) ;

	pWnd->GetWindowRect( &rect);
	ScreenToClient( &rect);
	
	m_Echelle.Create( WS_VISIBLE|WS_CHILD|TBS_HORZ|TBS_TOP|TBS_AUTOTICKS,
					 rect, this, IDD_DGMANAGER_DIALOG );
	m_Echelle.SetTicFreq((m_Echelle_min-m_Echelle_max)/10);
	m_Echelle.SetRange(m_Echelle_min,m_Echelle_max, TRUE);
	m_Echelle.SetPos(25000);

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDGManagerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}



// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDGManagerDlg::OnPaint() 
{
	CPaintDC dc(this);
	
	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		//affichage de l'chelle
		dc.SelectObject(&font);
		dc.SetTextColor(RGB(0,0,0));
		CString text;
		
		for (int i=0;i<12;i++) {
			text.Format("%u",i*(atoi(m_VEchelle)/1000));
			dc.TextOut(170+i*25,375,text);
		}

		for (i=0;i<13;i++) {
			text.Format("%u",i*m_Amplitude/11);
			dc.TextOut(150,370-i*25,text);
		}
		
		
		CDialog::OnPaint();
	}
	
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDGManagerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDGManagerDlg::OnAbout() 
{
	CAboutDlg About;
	About.DoModal();
	
}

void CDGManagerDlg::OnFichierQuitter() 
{
	KillTimer(ID_CLOCK_TIMER); // arrte le timer
	KillTimer(ID_BAUD_TIMER); // arrte le timer
	CloseHandle(cf); // fermeture du port de communication
	UpdateData(FALSE); // met  jour la fentre
	OnOK();	
}

void CDGManagerDlg::OnGloveConnect() 
{
	CDlgPort DlgPort;
	// Active COM 1 par dfaut
	DlgPort.m_Com=0;
	
	if (DlgPort.DoModal() == IDOK)
	{
		// l'utilisateur  choisi OK
		switch(DlgPort.m_Com)
		{
			case 0: // Ouvertue du port COM1
				cf=OpenDGComm("COM1");
				break;
			case 1: // Ouverture du port COM2
				cf=OpenDGComm("COM2");
				break;
		}

		if(cf)
		{
			SetTimer(ID_CLOCK_TIMER,10,NULL); // timer 50 fois par seconde pour les acquisition
			SetTimer(ID_BAUD_TIMER,1000,NULL); // timer de 1 seconde pour mesurer des informations
			connected=true;
		}
	}

	
}

void CDGManagerDlg::OnAffichageOptions() 
{
	CDlgView DlgView;
	DlgView.m_RangeFrom.Format("%u",m_Echelle_min);
	DlgView.m_RangeTo.Format("%u",m_Echelle_max);
	DlgView.m_Amplitude.Format("%u",m_Amplitude);
	DlgView.m_Defil=m_scope;
	if(m_raw_data==true)
		DlgView.m_Donnee=0;
	if(m_scaled_data==true)
		DlgView.m_Donnee=1;
	if(m_calibrate_data==true)
		DlgView.m_Donnee=2;

	
	if (DlgView.DoModal() == IDOK)
	{
		// l'utilisateur  choisit OK
		m_Echelle_min=atoi(DlgView.m_RangeFrom);
		m_Echelle_max=atoi(DlgView.m_RangeTo);
		m_Echelle.SetTicFreq((m_Echelle_min-m_Echelle_max)/10);
	    m_Echelle.SetRange(m_Echelle_min,m_Echelle_max, TRUE);
		m_Amplitude=atoi(DlgView.m_Amplitude);
		
		switch(DlgView.m_Donnee) {
			case 0:
				m_raw_data=true;
			break;
			case 1:
				m_scaled_data=true;
			break;
			case 2:
				m_calibrate_data=true;
			break;
		}
		
		m_scope=DlgView.m_Defil;

		Invalidate();
	}
	
}

void CDGManagerDlg::OnTimer(UINT nIDEvent) 
{
	// temporisateur ayant fait l'interruption

	switch(nIDEvent)
	{
		case ID_CLOCK_TIMER:
			m_IDebit+=ReadDGComm(cf);

			//Affichage des differents canaux
			if (AN_ext[2]!=0) {
				m_AN1.Format("%u",AN_ext[2]);
				m_IFreq+=1;
			}
			if (AN_ext[3]!=0)
				m_AN2.Format("%u",AN_ext[3]);
			if (AN_ext[4]!=0)
				m_AN3.Format("%u",AN_ext[4]);
			if (AN_ext[5]!=0)
				m_AN4.Format("%u",AN_ext[5]);
			if (AN_ext[6]!=0)
				m_AN5.Format("%u",AN_ext[6]);
			if (AN_ext[7]!=0)
				m_AN6.Format("%u",AN_ext[7]);
			if (AN_ext[10]!=0)
				m_AN7.Format("%u",AN_ext[10]);
			if (AN_ext[11]!=0)
				m_AN8.Format("%u",AN_ext[11]);
			if (AN_ext[12]!=0)
				m_AN9.Format("%u",AN_ext[12]);
			if (AN_ext[13]!=0)
				m_AN10.Format("%u",AN_ext[13]);
			if (AN_ext[14]!=0)
				m_AN11.Format("%u",AN_ext[14]);
			if (AN_ext[18]!=0)
				m_AN12.Format("%u",AN_ext[18]);
			if (AN_ext[19]!=0)
				m_AN13.Format("%u",AN_ext[19]);
			if (AN_ext[20]!=0)
				m_AN14.Format("%u",AN_ext[20]);
			if (AN_ext[21]!=0)
				m_AN15.Format("%u",AN_ext[21]);
			if (AN_ext[22]!=0)
				m_AN16.Format("%u",AN_ext[22]);
			if (AN_ext[23]!=0)
				m_AN17.Format("%u",AN_ext[23]);
			if (AN_ext[26]!=0)
				m_AN18.Format("%u",AN_ext[26]);
			if (AN_ext[27]!=0)
				m_AN19.Format("%u",AN_ext[27]);
			if (AN_ext[28]!=0)
				m_AN20.Format("%u",AN_ext[28]);
			if (AN_ext[29]!=0)
				m_AN21.Format("%u",AN_ext[29]);
			if (AN_ext[30]!=0)
				m_AN22.Format("%u",AN_ext[30]);
			if (AN_ext[31]!=0)
				m_AN23.Format("%u",AN_ext[31]);
			if (AN_ext[15]!=0)
				m_AN24.Format("%u",AN_ext[15]);

			// Calibration du gant
			if (m_StatCalibrate==true)
			{
				// Enregistrement des valeurs reu
				for(int i=0;i<15;i++) {
					if(AN_ext[Convert(m_Param[i].m_AN-1)]!=0 && m_Param[i].m_Min>AN_ext[Convert(m_Param[i].m_AN-1)])
						m_Param[i].m_Min=AN_ext[Convert(m_Param[i].m_AN-1)];
					if(AN_ext[m_Param[i].m_AN-1]!=0 && m_Param[i].m_Max<AN_ext[Convert(m_Param[i].m_AN-1)])
						m_Param[i].m_Max=AN_ext[Convert(m_Param[i].m_AN-1)];
				}
				if ((m_Ifps)%7==1 && m_Etalonnage.m_StatBegin==true) {
					m_Etalonnage.m_EtalonnageBar.SetPos(Pos);
					Pos++;
					if(Pos==100) {
						m_Etalonnage.OnFerme();
						m_Etalonnage.m_StatBegin=false;
					}
				}
			}


			// Gestion des informations
			m_Ifps+=1;
			
			// arrte le timer si tableau remplit
			if(Timer==100000)
				go=false;

			// Sauvegarde de donne
			if(go==true && AN_ext[Canal]!=0) {
				Timer=Timer+1;	// Compte le temps d'acquisition
				tabl[Timer]=AN_ext[Canal];
			}

			if(Timer==(m_Echelle.GetPos()/64))
				go=false;
			
			// Raffiche le graphique
			m_pDisplay.Invalidate();

			// Actualise l'affichage de la main3D
			if(m_View3D==true)
				SendAxe(); // Apel la fonction de calcul des donnes  envoyer


		break;
			
			// effectuer toute les secondes pour calcul de stat
		case ID_BAUD_TIMER:
				m_Fps.Format("%u",m_Ifps);
				m_debit.Format("%u bps",m_IDebit*8);
				m_Freq.Format("Freq de rafrachissement : %u Hz", m_IFreq);
				m_IFreq=0;
				m_Ifps=0;
				m_IDebit=0;
		break;

	}

	// Met  jour la fentre
	UpdateData(FALSE);


	CDialog::OnTimer(nIDEvent);
}

void CDGManagerDlg::OnGo() 
{
	Timer=0;
	go=true;
}

void CDGManagerDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_VEchelle.Format("%u",m_Echelle.GetPos()); // Rcupre la position
	
	if( go==true)
		go=false;

	UpdateData(FALSE);

	// Rafrachit ce qui a tait modifier
	RECT RefreshRect;
	RefreshRect.left=140;
	RefreshRect.top=375;
	RefreshRect.right=480;
	RefreshRect.bottom=390;
	
	InvalidateRect(&RefreshRect,true);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDGManagerDlg::OnSelchangeCombo1() 
{
	UpdateData();
	
	// affectation du numro de canal
	Canal=Convert(m_Canaux);

	UpdateData(FALSE);
	
}


void CDGManagerDlg::OnFichierEnregistrerlog() 
{
	HANDLE file;
	DWORD nbWrite;
	char buf[8];

	CFileDialog m_Openfile(FALSE,"csv","*.csv",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"CSV Excel format",NULL);
	
	m_Openfile.DoModal();

	file = CreateFile(m_Openfile.GetFileName(), GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, NULL);

	for(int i=1;i<Timer;i++) {
		sprintf(buf,"%d;%d%c%c",i,tabl[i],0x0D,0x0A);
		WriteFile(file, &buf, sizeof(buf), &nbWrite, NULL);
	}
	
	CloseHandle(file);
	
}

void CDGManagerDlg::OnGloveCalibrate() 
{;
	// initialisation du tabelau de classe
	for(int i=0;i<15;i++) {
		m_Param[i].m_Min=1024;
		m_Param[i].m_Max=0;
	}
	Pos=0;

	m_StatCalibrate=true;
	
	m_Etalonnage.DoModal();

	m_StatCalibrate=false;

	// Calcul de la dynamique du doigt
	for (i=0;i<15;i++)	{
		m_Param[i].m_Range=m_Param[i].m_Max-m_Param[i].m_Min;
	}

	UpdateData(FALSE);

	m_DlgCalibrate.SetInfo(m_Param);
	
	m_DlgCalibrate.DoModal();
	
	
	UpdateData(FALSE);
	
}

void CDGManagerDlg::OnFileOpen() 
{
	CString Section;
	
	CFile *pFile = new CFile();
	ASSERT (pFile != NULL);
	
	CFileDialog m_Openfile(TRUE,"cal","*.cal",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"CAL Calibration File",NULL);

	m_Openfile.DoModal();

	// Chargement de la calibration
	CIniEx ini;

	ini.Open(m_Openfile.GetFileName());
	for(int i=0;i<15;i++) {
		Section.Format("Articulation %u",i);
		m_Param[i].m_Name=ini.GetValue(Section,"Mame");
		m_Param[i].m_AN=atoi(ini.GetValue(Section,"AN"));
		m_Param[i].m_Min=atoi(ini.GetValue(Section,"Min"));
		m_Param[i].m_Max=atoi(ini.GetValue(Section,"Max"));
		m_Param[i].m_Range=atoi(ini.GetValue(Section,"Range"));
		m_Param[i].m_Angle_Max=atoi(ini.GetValue(Section,"Angle_Max"));
	}

	
	
}

void CDGManagerDlg::OnFileSave() 
{
	CString Section,Value;
	CFile *pFile = new CFile();
	ASSERT (pFile != NULL);
	
	CFileDialog m_Openfile(FALSE,"cal","*.cal",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"CAL Calibration File",NULL);

	m_Openfile.DoModal();

	// Sauvegarde de la calibration
	CIniEx ini;
	ini.Open(m_Openfile.GetFileName());

	for(int i=0;i<15;i++) {
		Section.Format("Articulation %u",i);
		ini.SetValue(Section,"Mame",m_Param[i].m_Name);
		Value.Format("%u",m_Param[i].m_AN);
		ini.SetValue(Section,"AN",Value);
		Value.Format("%u",m_Param[i].m_Min);
		ini.SetValue(Section,"Min",Value);
		Value.Format("%u",m_Param[i].m_Max);
		ini.SetValue(Section,"Max",Value);
		Value.Format("%u",m_Param[i].m_Range);
		ini.SetValue(Section,"Range",Value);
		Value.Format("%u",m_Param[i].m_Angle_Max);
		ini.SetValue(Section,"Angle_Max",Value);
	}

	
}

void CDGManagerDlg::OnGloveConfig() 
{
	CDlgConfig m_Config;

	m_Config.m_P1=m_P1;

	m_Config.m_ANG1.Format("%u",m_Param[0].m_Angle_Max);
	m_Config.m_ANG2.Format("%u",m_Param[1].m_Angle_Max);
	m_Config.m_ANG3.Format("%u",m_Param[2].m_Angle_Max);
	m_Config.m_ANG4.Format("%u",m_Param[3].m_Angle_Max);
	m_Config.m_ANG5.Format("%u",m_Param[4].m_Angle_Max);
	m_Config.m_ANG6.Format("%u",m_Param[5].m_Angle_Max);
	m_Config.m_ANG7.Format("%u",m_Param[6].m_Angle_Max);
	m_Config.m_ANG8.Format("%u",m_Param[7].m_Angle_Max);
	m_Config.m_ANG9.Format("%u",m_Param[8].m_Angle_Max);
	m_Config.m_ANG10.Format("%u",m_Param[9].m_Angle_Max);
	m_Config.m_ANG11.Format("%u",m_Param[10].m_Angle_Max);
	m_Config.m_ANG12.Format("%u",m_Param[11].m_Angle_Max);
	m_Config.m_ANG13.Format("%u",m_Param[12].m_Angle_Max);
	m_Config.m_ANG14.Format("%u",m_Param[13].m_Angle_Max);
	m_Config.m_P1algmax.Format("%u",m_Param[14].m_Angle_Max);

	m_Config.m_ART1.Format("%u",m_Param[0].m_AN);
	m_Config.m_ART2.Format("%u",m_Param[1].m_AN);
	m_Config.m_ART3.Format("%u",m_Param[2].m_AN);
	m_Config.m_ART4.Format("%u",m_Param[3].m_AN);
	m_Config.m_ART5.Format("%u",m_Param[4].m_AN);
	m_Config.m_ART6.Format("%u",m_Param[5].m_AN);
	m_Config.m_ART7.Format("%u",m_Param[6].m_AN);
	m_Config.m_ART8.Format("%u",m_Param[7].m_AN);
	m_Config.m_ART9.Format("%u",m_Param[8].m_AN);
	m_Config.m_ART10.Format("%u",m_Param[9].m_AN);
	m_Config.m_ART11.Format("%u",m_Param[10].m_AN);
	m_Config.m_ART12.Format("%u",m_Param[11].m_AN);
	m_Config.m_ART13.Format("%u",m_Param[12].m_AN);
	m_Config.m_ART14.Format("%u",m_Param[13].m_AN);
	m_Config.m_P1AN.Format("%u",m_Param[14].m_AN);


	if(m_Config.DoModal() == IDOK)
	{
		m_Param[0].m_Angle_Max=atoi(m_Config.m_ANG1);
		m_Param[1].m_Angle_Max=atoi(m_Config.m_ANG2);
		m_Param[2].m_Angle_Max=atoi(m_Config.m_ANG3);
		m_Param[3].m_Angle_Max=atoi(m_Config.m_ANG4);
		m_Param[4].m_Angle_Max=atoi(m_Config.m_ANG5);
		m_Param[5].m_Angle_Max=atoi(m_Config.m_ANG6);
		m_Param[6].m_Angle_Max=atoi(m_Config.m_ANG7);
		m_Param[7].m_Angle_Max=atoi(m_Config.m_ANG8);
		m_Param[8].m_Angle_Max=atoi(m_Config.m_ANG9);
		m_Param[9].m_Angle_Max=atoi(m_Config.m_ANG10);
		m_Param[10].m_Angle_Max=atoi(m_Config.m_ANG11);
		m_Param[11].m_Angle_Max=atoi(m_Config.m_ANG12);
		m_Param[12].m_Angle_Max=atoi(m_Config.m_ANG13);
		m_Param[13].m_Angle_Max=atoi(m_Config.m_ANG14);
		m_Param[14].m_Angle_Max=atoi(m_Config.m_P1algmax);
		
		m_Param[0].m_AN=atoi(m_Config.m_ART1);
		m_Param[1].m_AN=atoi(m_Config.m_ART2);
		m_Param[2].m_AN=atoi(m_Config.m_ART3);
		m_Param[3].m_AN=atoi(m_Config.m_ART4);
		m_Param[4].m_AN=atoi(m_Config.m_ART5);
		m_Param[5].m_AN=atoi(m_Config.m_ART6);
		m_Param[6].m_AN=atoi(m_Config.m_ART7);
		m_Param[7].m_AN=atoi(m_Config.m_ART8);
		m_Param[8].m_AN=atoi(m_Config.m_ART9);
		m_Param[9].m_AN=atoi(m_Config.m_ART10);
		m_Param[10].m_AN=atoi(m_Config.m_ART11);
		m_Param[11].m_AN=atoi(m_Config.m_ART12);
		m_Param[12].m_AN=atoi(m_Config.m_ART13);
		m_Param[13].m_AN=atoi(m_Config.m_ART14);
		m_Param[14].m_AN=atoi(m_Config.m_P1AN);

		m_P1=m_Config.m_P1;
	}


	// Remplit la case des noms associer  chaque doigt
	m_Param[0].m_Name="Auriculaire1";
	m_Param[1].m_Name="Auriculaire2";
	m_Param[2].m_Name="Auriculaire3";
	m_Param[3].m_Name="Annulaire1";
	m_Param[4].m_Name="Annulaire2";
	m_Param[5].m_Name="Annulaire3";
	m_Param[6].m_Name="Majeur1";
	m_Param[7].m_Name="Majeur2";
	m_Param[8].m_Name="Majeur3";
	m_Param[9].m_Name="Index1";
	m_Param[10].m_Name="Index2";
	m_Param[11].m_Name="Index3";
	m_Param[12].m_Name="Pouce1";
	m_Param[13].m_Name="Pouce2";
	m_Param[14].m_Name="Pivot 1";

}

void CDGManagerDlg::OnGloveMain3d() 
{
	m_View3D=true;
	Hand();
}

void CDGManagerDlg::SendAxe() 
{

	for(int i=0;i<14;i++) {
		if (AN_ext[Convert(m_Param[i].m_AN-1)]!=0) {
			m_Hand[i]=((float)AN_ext[Convert(m_Param[i].m_AN-1)]*((float)m_Param[i].m_Angle_Max/(float)m_Param[i].m_Range)-((float)m_Param[i].m_Angle_Max*(float)m_Param[i].m_Min)/(float)m_Param[i].m_Range)-(float)m_Param[i].m_Angle_Max;
		}
	}

	if (AN_ext[Convert(m_Param[14].m_AN-1)]!=0 && m_P1==true)
		 	m_Hand[14]=20.0f-((float)AN_ext[Convert(m_Param[14].m_AN-1)]*((float)m_Param[14].m_Angle_Max/(float)m_Param[14].m_Range)-((float)m_Param[14].m_Angle_Max*(float)m_Param[14].m_Min)/(float)m_Param[14].m_Range)-(float)m_Param[14].m_Angle_Max;
	else
			m_Hand[14]=0;

	SetAxe(m_Hand);


}

int CDGManagerDlg::Convert(int Axe) {

	int CAxe;

	switch(Axe) 
	{
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		CAxe=Axe+2;
		break;
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		CAxe=Axe+4;
		break;
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		CAxe=Axe+7;
		break;
		case 17:
		case 18:
		case 19:
		case 20:
		case 21:
		case 22:
		CAxe=Axe+9;
		break;
		case 23:
		CAxe=15;
		break;
	}

	return CAxe;

}
