// DlgCalibrate.cpp : implementation file
//

#include "stdafx.h"
#include "DGManager.h"
#include "DlgCalibrate.h"
#include "DGComm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCalibrate dialog


CDlgCalibrate::CDlgCalibrate(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCalibrate::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCalibrate)
	//}}AFX_DATA_INIT

}


void CDlgCalibrate::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCalibrate)
	DDX_Control(pDX, IDC_CalibrateGrid, m_CalibrateGrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCalibrate, CDialog)
	//{{AFX_MSG_MAP(CDlgCalibrate)
	ON_BN_CLICKED(IDC_Calibrate, OnCalibrate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCalibrate message handlers

BOOL CDlgCalibrate::OnInitDialog()
{
	CDialog::OnInitDialog();

	return TRUE;
}

void CDlgCalibrate::SetInfo(CCalibrate* Param)
{
	for(int i=0;i<15;i++)	{
		m_Param[i].m_Name=Param[i].m_Name;
		m_Param[i].m_Min=Param[i].m_Min;
		m_Param[i].m_Max=Param[i].m_Max;
		m_Param[i].m_AN=Param[i].m_AN;
		m_Param[i].m_Angle_Max=Param[i].m_Angle_Max;
		m_Param[i].m_Range=Param[i].m_Range;
	}
}

void CDlgCalibrate::OnCalibrate() 
{
    CString buf;
	
	for(int i=1;i<16;i++) {
		buf.Format("%u",m_Param[i-1].m_Min);
		m_CalibrateGrid.SetTextMatrix(i,1,buf);
		buf.Format("%u",m_Param[i-1].m_Max);
		m_CalibrateGrid.SetTextMatrix(i,2,buf);	
		buf.Format("%u",m_Param[i-1].m_Range);
		m_CalibrateGrid.SetTextMatrix(i,3,buf);	
		buf.Format("%u",m_Param[i-1].m_AN);
		m_CalibrateGrid.SetTextMatrix(i,4,buf);
		buf.Format("%u",m_Param[i-1].m_Angle_Max);
		m_CalibrateGrid.SetTextMatrix(i,5,buf);
		m_CalibrateGrid.SetTextMatrix(i,0,m_Param[i-1].m_Name);	
	}
}
