// EtalonnageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Etalonnage.h"
#include "EtalonnageDlg.h"
#include "progressbar.h"
#include "IniEx.h"
#include "EnBitmap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CEnBitmap bitmap;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEtalonnageDlg dialog

CEtalonnageDlg::CEtalonnageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEtalonnageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEtalonnageDlg)
	m_instruction = _T("");
	m_timer = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEtalonnageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEtalonnageDlg)
	DDX_Control(pDX, IDC_PDL, m_progressbar);
	DDX_Control(pDX, ID_OK, m_btn_ok);
	DDX_Control(pDX, ID_CANCEL, m_btn_cancel);
	DDX_Text(pDX, IDC_INSTRUCTION, m_instruction);
	DDX_Text(pDX, IDC_TIMER, m_timer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEtalonnageDlg, CDialog)
	//{{AFX_MSG_MAP(CEtalonnageDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_OK, OnOk)
	ON_BN_CLICKED(ID_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEtalonnageDlg message handlers

BOOL CEtalonnageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_progressbar.SetRange(0,100);
	m_progressbar.SetStep(0);
	m_instruction.Format("Une fois la squence d'talonnage mise en route, vous allez devoir effectuer diffrents mouvements avec le gant.");
	UpdateData(false);

	bitmap.LoadImage("logo.jpeg");
	m_bitmap.DeleteObject();
	m_bitmap.Attach(bitmap.Detach());
	Invalidate();
	UpdateWindow();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEtalonnageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEtalonnageDlg::OnPaint() 
{
/*	if (IsIconic())
	{*/
		CPaintDC dc(this); // device context for painting
/*
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
*/
		if (m_bitmap.GetSafeHandle())
		{
			CDC dcMem;

			if (dcMem.CreateCompatibleDC(&dc))
			{
				CBitmap* pOldBM = dcMem.SelectObject(&m_bitmap);
				BITMAP BM;

				m_bitmap.GetBitmap(&BM);
				dc.BitBlt(340, 30, 340+BM.bmWidth, 30+BM.bmHeight, &dcMem, 0, 0, SRCCOPY);
				dcMem.SelectObject(pOldBM);	
			}
		}
/*	}
	else
	{
		CDialog::OnPaint();
	}
*/
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEtalonnageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

char* GetAppDir()
{
 static char pAppDir[100];
 char pTmpDir[100];

 GetModuleFileName(NULL,(LPTSTR)pTmpDir,100);

 for(int i=strlen(pTmpDir); i>0; i--){
  if(pTmpDir[i]=='\\')
   break;
 }

 for(int j=0; j<i; j++)
  pAppDir[j]=pTmpDir[j];

 pAppDir[j+1]='\0';

 return pAppDir;
}

void CEtalonnageDlg::OnOk() 
{
/*  // Pour lire dans un fichier ini
	BOOL CIniEx::Open(	LPCSTR pFileName, 
					    BOOL writeWhenChange,	//=TRUE
						BOOL createIfNotExist,	//=TRUE
						BOOL noCaseSensitive,	//=TRUE
						BOOL makeBackup);		//=FALSE

	CIniEx ini;
	CString value;
	ini.Open("c:\\temp\\new.ini");
	value=ini.GetValue("MaxUser");				// Cle
	value=ini.GetValue("Settings","MRU1");		// Section, cle
	value=ini.GetValue("Users","root","200");	// Section, cle, valeur par defaut
*/

	CIniEx ini;
	ini.Open(GetAppDir() + CString("\\config.ini"));

	m_btn_ok.EnableWindow(false);
	m_btn_cancel.EnableWindow(false);	

	// Phase 1
	m_instruction.Format("Placez votre main suivant la position prsente sur l'image :");
	UpdateData(false);
	bitmap.LoadImage("image1.jpeg");
	m_bitmap.DeleteObject();
	m_bitmap.Attach(bitmap.Detach());
	Invalidate();
	UpdateWindow();

	int j=0;
	while (j<=5) {
		m_timer.Format("Dbut de la phase 1/2 dans %i seconde(s) !",6-j);
		UpdateData(false);
	    Sleep(1000);
		j++;
    }
	m_instruction.Format("");
	m_timer.Format("");
	UpdateData(false);

	int i = 1;
	do {
		m_progressbar.SetPos(i);
		Sleep(7);
		i++;
	} while ( i <= 100);
	ini.SetValue("Articulation 1","Min","5");
	ini.SetValue("Articulation 1","Max","8");

	// Phase 2
	m_instruction.Format("Placez votre main suivant la position prsente sur l'image :");
	UpdateData(false);
	bitmap.LoadImage("image2.jpeg");
	m_bitmap.DeleteObject();
	m_bitmap.Attach(bitmap.Detach());
	Invalidate();
	UpdateWindow();

	j=0;
	m_progressbar.SetPos(0);
	while (j<=5) {
		m_timer.Format("Dbut de la phase 2/2 dans %i seconde(s) !",6-j);
		UpdateData(false);
	    Sleep(1000);
		j++;
    }
	m_instruction.Format("");
	m_timer.Format("");
	UpdateData(false);

	i = 1;
	do {
		m_progressbar.SetPos(i);
		Sleep(7);
		i++;
	} while ( i <= 100);
	ini.SetValue("Articulation 2","Min","6");
	ini.SetValue("Articulation 2","Max","9");

	bitmap.LoadImage("logo.jpeg");
	m_bitmap.DeleteObject();
	m_bitmap.Attach(bitmap.Detach());
	Invalidate();
	UpdateWindow();
	m_instruction.Format("Une fois la squence d'talonnage mise en route, vous allez devoir effectuer diffrents mouvements avec le gant.");
	UpdateData(false);
	m_btn_ok.EnableWindow(true);
	m_btn_cancel.EnableWindow(true);
	m_progressbar.SetPos(0);
	MessageBox("L'talonnage est arrive  terme. Bravo !");
}

void CEtalonnageDlg::OnCancel() 
{
	CDialog::OnCancel();
}


